<?php
/**
 * GeraetApi
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use SLIS\Adapter\Hub\ApiException;
use SLIS\Adapter\Hub\Configuration;
use SLIS\Adapter\Hub\HeaderSelector;
use SLIS\Adapter\Hub\ObjectSerializer;

/**
 * GeraetApi Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class GeraetApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation deleteGeraetItem
     *
     * Removes the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function deleteGeraetItem($uuid)
    {
        $this->deleteGeraetItemWithHttpInfo($uuid);
    }

    /**
     * Operation deleteGeraetItemWithHttpInfo
     *
     * Removes the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteGeraetItemWithHttpInfo($uuid)
    {
        $request = $this->deleteGeraetItemRequest($uuid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation deleteGeraetItemAsync
     *
     * Removes the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteGeraetItemAsync($uuid)
    {
        return $this->deleteGeraetItemAsyncWithHttpInfo($uuid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteGeraetItemAsyncWithHttpInfo
     *
     * Removes the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteGeraetItemAsyncWithHttpInfo($uuid)
    {
        $returnType = '';
        $request = $this->deleteGeraetItemRequest($uuid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteGeraetItem'
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function deleteGeraetItemRequest($uuid)
    {

        // verify the required parameter 'uuid' is set
        if ($uuid === null || (is_array($uuid) && count($uuid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $uuid when calling deleteGeraetItem'
            );
        }

        $resourcePath = '/geraets/{uuid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($uuid !== null) {
            $resourcePath = str_replace(
                '{' . 'uuid' . '}',
                ObjectSerializer::toPathValue($uuid),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                []
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                [],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'DELETE',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getGeraetCollection
     *
     * Retrieves the collection of Geraet resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     * @param  string $externalIdentifier  (optional)
     * @param  string[] $externalIdentifier2  (optional)
     * @param  string $ip  (optional)
     * @param  string[] $ip2  (optional)
     * @param  string $mac  (optional)
     * @param  string $seriennummer  (optional)
     * @param  string[] $seriennummer2  (optional)
     * @param  string $tags  (optional)
     * @param  string[] $tags2  (optional)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\GetGeraetCollection200Response
     */
    public function getGeraetCollection($page = 1, $externalIdentifier = null, $externalIdentifier2 = null, $ip = null, $ip2 = null, $mac = null, $seriennummer = null, $seriennummer2 = null, $tags = null, $tags2 = null)
    {
        list($response) = $this->getGeraetCollectionWithHttpInfo($page, $externalIdentifier, $externalIdentifier2, $ip, $ip2, $mac, $seriennummer, $seriennummer2, $tags, $tags2);
        return $response;
    }

    /**
     * Operation getGeraetCollectionWithHttpInfo
     *
     * Retrieves the collection of Geraet resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     * @param  string $externalIdentifier  (optional)
     * @param  string[] $externalIdentifier2  (optional)
     * @param  string $ip  (optional)
     * @param  string[] $ip2  (optional)
     * @param  string $mac  (optional)
     * @param  string $seriennummer  (optional)
     * @param  string[] $seriennummer2  (optional)
     * @param  string $tags  (optional)
     * @param  string[] $tags2  (optional)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\GetGeraetCollection200Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function getGeraetCollectionWithHttpInfo($page = 1, $externalIdentifier = null, $externalIdentifier2 = null, $ip = null, $ip2 = null, $mac = null, $seriennummer = null, $seriennummer2 = null, $tags = null, $tags2 = null)
    {
        $request = $this->getGeraetCollectionRequest($page, $externalIdentifier, $externalIdentifier2, $ip, $ip2, $mac, $seriennummer, $seriennummer2, $tags, $tags2);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Hub\Model\GetGeraetCollection200Response' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\GetGeraetCollection200Response' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\GetGeraetCollection200Response', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\GetGeraetCollection200Response';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\GetGeraetCollection200Response',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getGeraetCollectionAsync
     *
     * Retrieves the collection of Geraet resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     * @param  string $externalIdentifier  (optional)
     * @param  string[] $externalIdentifier2  (optional)
     * @param  string $ip  (optional)
     * @param  string[] $ip2  (optional)
     * @param  string $mac  (optional)
     * @param  string $seriennummer  (optional)
     * @param  string[] $seriennummer2  (optional)
     * @param  string $tags  (optional)
     * @param  string[] $tags2  (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getGeraetCollectionAsync($page = 1, $externalIdentifier = null, $externalIdentifier2 = null, $ip = null, $ip2 = null, $mac = null, $seriennummer = null, $seriennummer2 = null, $tags = null, $tags2 = null)
    {
        return $this->getGeraetCollectionAsyncWithHttpInfo($page, $externalIdentifier, $externalIdentifier2, $ip, $ip2, $mac, $seriennummer, $seriennummer2, $tags, $tags2)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getGeraetCollectionAsyncWithHttpInfo
     *
     * Retrieves the collection of Geraet resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     * @param  string $externalIdentifier  (optional)
     * @param  string[] $externalIdentifier2  (optional)
     * @param  string $ip  (optional)
     * @param  string[] $ip2  (optional)
     * @param  string $mac  (optional)
     * @param  string $seriennummer  (optional)
     * @param  string[] $seriennummer2  (optional)
     * @param  string $tags  (optional)
     * @param  string[] $tags2  (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getGeraetCollectionAsyncWithHttpInfo($page = 1, $externalIdentifier = null, $externalIdentifier2 = null, $ip = null, $ip2 = null, $mac = null, $seriennummer = null, $seriennummer2 = null, $tags = null, $tags2 = null)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\GetGeraetCollection200Response';
        $request = $this->getGeraetCollectionRequest($page, $externalIdentifier, $externalIdentifier2, $ip, $ip2, $mac, $seriennummer, $seriennummer2, $tags, $tags2);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getGeraetCollection'
     *
     * @param  int $page The collection page number (optional, default to 1)
     * @param  string $externalIdentifier  (optional)
     * @param  string[] $externalIdentifier2  (optional)
     * @param  string $ip  (optional)
     * @param  string[] $ip2  (optional)
     * @param  string $mac  (optional)
     * @param  string $seriennummer  (optional)
     * @param  string[] $seriennummer2  (optional)
     * @param  string $tags  (optional)
     * @param  string[] $tags2  (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function getGeraetCollectionRequest($page = 1, $externalIdentifier = null, $externalIdentifier2 = null, $ip = null, $ip2 = null, $mac = null, $seriennummer = null, $seriennummer2 = null, $tags = null, $tags2 = null)
    {











        $resourcePath = '/geraets';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $page,
            'page', // param base name
            'integer', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $externalIdentifier,
            'externalIdentifier', // param base name
            'string', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $externalIdentifier2,
            'externalIdentifier[]', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $ip,
            'ip', // param base name
            'string', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $ip2,
            'ip[]', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $mac,
            'mac', // param base name
            'string', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $seriennummer,
            'seriennummer', // param base name
            'string', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $seriennummer2,
            'seriennummer[]', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $tags,
            'tags', // param base name
            'string', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $tags2,
            'tags[]', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);




        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getGeraetItem
     *
     * Retrieves a Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead
     */
    public function getGeraetItem($uuid)
    {
        list($response) = $this->getGeraetItemWithHttpInfo($uuid);
        return $response;
    }

    /**
     * Operation getGeraetItemWithHttpInfo
     *
     * Retrieves a Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead, HTTP status code, HTTP response headers (array of strings)
     */
    public function getGeraetItemWithHttpInfo($uuid)
    {
        $request = $this->getGeraetItemRequest($uuid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getGeraetItemAsync
     *
     * Retrieves a Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getGeraetItemAsync($uuid)
    {
        return $this->getGeraetItemAsyncWithHttpInfo($uuid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getGeraetItemAsyncWithHttpInfo
     *
     * Retrieves a Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getGeraetItemAsyncWithHttpInfo($uuid)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead';
        $request = $this->getGeraetItemRequest($uuid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getGeraetItem'
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function getGeraetItemRequest($uuid)
    {

        // verify the required parameter 'uuid' is set
        if ($uuid === null || (is_array($uuid) && count($uuid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $uuid when calling getGeraetItem'
            );
        }

        $resourcePath = '/geraets/{uuid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($uuid !== null) {
            $resourcePath = str_replace(
                '{' . 'uuid' . '}',
                ObjectSerializer::toPathValue($uuid),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation putGeraetItem
     *
     * Replaces the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     * @param  \SLIS\Adapter\Hub\Model\GeraetJsonldWriteGeraetWrite $geraetJsonldWriteGeraetWrite The updated Geraet resource (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead
     */
    public function putGeraetItem($uuid, $geraetJsonldWriteGeraetWrite)
    {
        list($response) = $this->putGeraetItemWithHttpInfo($uuid, $geraetJsonldWriteGeraetWrite);
        return $response;
    }

    /**
     * Operation putGeraetItemWithHttpInfo
     *
     * Replaces the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     * @param  \SLIS\Adapter\Hub\Model\GeraetJsonldWriteGeraetWrite $geraetJsonldWriteGeraetWrite The updated Geraet resource (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead, HTTP status code, HTTP response headers (array of strings)
     */
    public function putGeraetItemWithHttpInfo($uuid, $geraetJsonldWriteGeraetWrite)
    {
        $request = $this->putGeraetItemRequest($uuid, $geraetJsonldWriteGeraetWrite);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation putGeraetItemAsync
     *
     * Replaces the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     * @param  \SLIS\Adapter\Hub\Model\GeraetJsonldWriteGeraetWrite $geraetJsonldWriteGeraetWrite The updated Geraet resource (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function putGeraetItemAsync($uuid, $geraetJsonldWriteGeraetWrite)
    {
        return $this->putGeraetItemAsyncWithHttpInfo($uuid, $geraetJsonldWriteGeraetWrite)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation putGeraetItemAsyncWithHttpInfo
     *
     * Replaces the Geraet resource.
     *
     * @param  string $uuid Resource identifier (required)
     * @param  \SLIS\Adapter\Hub\Model\GeraetJsonldWriteGeraetWrite $geraetJsonldWriteGeraetWrite The updated Geraet resource (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function putGeraetItemAsyncWithHttpInfo($uuid, $geraetJsonldWriteGeraetWrite)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\GeraetJsonldReadGeraetRead';
        $request = $this->putGeraetItemRequest($uuid, $geraetJsonldWriteGeraetWrite);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'putGeraetItem'
     *
     * @param  string $uuid Resource identifier (required)
     * @param  \SLIS\Adapter\Hub\Model\GeraetJsonldWriteGeraetWrite $geraetJsonldWriteGeraetWrite The updated Geraet resource (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function putGeraetItemRequest($uuid, $geraetJsonldWriteGeraetWrite)
    {

        // verify the required parameter 'uuid' is set
        if ($uuid === null || (is_array($uuid) && count($uuid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $uuid when calling putGeraetItem'
            );
        }

        // verify the required parameter 'geraetJsonldWriteGeraetWrite' is set
        if ($geraetJsonldWriteGeraetWrite === null || (is_array($geraetJsonldWriteGeraetWrite) && count($geraetJsonldWriteGeraetWrite) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $geraetJsonldWriteGeraetWrite when calling putGeraetItem'
            );
        }

        $resourcePath = '/geraets/{uuid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($uuid !== null) {
            $resourcePath = str_replace(
                '{' . 'uuid' . '}',
                ObjectSerializer::toPathValue($uuid),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                ['application/ld+json', 'application/json', 'text/html']
            );
        }

        // for model (json/xml)
        if (isset($geraetJsonldWriteGeraetWrite)) {
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($geraetJsonldWriteGeraetWrite));
            } else {
                $httpBody = $geraetJsonldWriteGeraetWrite;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'PUT',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
